<template>
    <div class="container">
        <div class="header">
            <div class="title">
                <i class="title-icon"></i>
                <span class="title-text">专项工程统计</span>
            </div>
            <i class="back-icon" @click="handleReset"></i>
        </div>
        <div class="search">
            <!-- <el-date-picker
                v-model="cissueDate"
                type="daterange"
                range-separator="至"
                format="yyyy-MM-dd"
                value-format="yyyy-MM-dd"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                :picker-options="pickerOption"
                @change="handleTimeChange"
                style="margin-right: 10px"
            >
            </el-date-picker> -->
            <el-date-picker
                v-model="searchForm.startDate"
                type="date"
                placeholder="请选择开始日期"
                value-format="yyyy-MM-dd"
            >
            </el-date-picker>
            <el-date-picker
                v-model="searchForm.endDate"
                type="date"
                placeholder="请选择结束日期"
                value-format="yyyy-MM-dd"
            >
            </el-date-picker>
            <el-button size="small" @click="findinfo" type="primary"> 查询 </el-button>
            <el-button size="small" @click="reset" type="plain">重置</el-button>
        </div>
        <div class="table">
            <el-table
                :data="tableData"
                stripe
                v-loading="loading"
                @row-click="hanldeRowClick"
                @cell-click="handleCellClick"
                header-cell-class-name="custom-header-cell"
                cell-class-name="custom-cell"
            >
                <el-table-column label="序号" type="index" width="70" align="center">
                </el-table-column>
                <el-table-column align="center" prop="name" label="名称" min-width="20%">
                    <template v-slot="{row}">
                        <i
                            class="el-icon-arrow-down"
                            v-if="row.name !== '总数'"
                            style="margin-right: 10px"
                        ></i>
                        {{ row.name }}
                    </template>
                </el-table-column>
                <el-table-column
                    min-width="20%"
                    align="center"
                    prop="payMoney"
                    label="计量金额(万元)"
                ></el-table-column>
                <el-table-column
                    min-width="20%"
                    align="center"
                    prop="payRate"
                    label="计量进度"
                >
                    <template v-slot="{row}">
                        <span class="cell" v-if="row.payRate">
                            {{ Number(row.payRate * 100).toFixed(2) + '%' }}
                        </span>
                        <span class="cell" v-else> 0.00% </span>
                    </template>
                </el-table-column>
                <el-table-column
                    min-width="20%"
                    align="center"
                    prop="projectCount"
                    label="项目数量"
                ></el-table-column>
                <el-table-column
                    min-width="20%"
                    align="center"
                    prop="projectMoney"
                    label="项目总金额(万元)"
                >
                    <template v-slot="{row}">
                        <span class="cell" v-if="row.projectMoney">
                            {{ Number(row.projectMoney).toFixed(2) }}
                        </span>
                        <span class="cell" v-else> 0.00% </span>
                    </template>
                </el-table-column>
            </el-table>
            <!-- <div class="table-total">
                <span>{{ tableData.length + 1 }}</span>
                <span>总数</span>
                <span>{{ total.countNum || 0 }}</span>
                <span>{{ total.peopleNum || 0 }}</span>
            </div> -->
        </div>
    </div>
</template>

<script>
import utils from '@/utils' // thousandBit格式化千分位
const BigNumber = require('bignumber.js')
export default {
    name: 'ManagementInfoStatistics',
    data() {
        return {
            tableData: [],
            data: [],
            loading: false,
            total: {},
            utils: utils,
            searchForm: {
                startDate: new Date().getFullYear() + '-01-01',
                endDate: new Date().getFullYear() + '-12-31',
            },
            cissueDate: [],
            pickerOption: {
                disabledDate: (time) => {
                    return time.getTime() > Date.now()
                },
            },
        }
    },
    created() {
        // 默认查询当年的数据
        // this.cissueDate = [
        //     new Date().getFullYear() + '-01-01',
        //     new Date().getFullYear() + '-12-31',
        // ]
        // this.searchForm = {
        //     startDate: new Date().getFullYear() + '-01-01',
        //     endDate: new Date().getFullYear() + '-12-31',
        // }
        this.findinfo()
    },
    methods: {
        reset() {
            this.cissueDate = []
            this.searchForm = {
                startDate: new Date().getFullYear() + '-01-01',
                endDate: new Date().getFullYear() + '-12-31',
            }
            this.loadData()
        },
        handleTimeChange(time) {
            this.searchForm.startDate = time[0]
            this.searchForm.endDate = time[1]
        },
        findinfo() {
            let obj = this.searchForm
            let arr = []
            for (let i in obj) {
                let str = null
                str = i + '=' + obj[i]
                arr.push(str)
            }
            let querys = '?' + arr.join('&')
            this.loadData(querys)
        },
        calculation(key, arr) {
            if (!key || arr.length === 0) return 0
            let total = new BigNumber(0)
            arr.forEach((item) => {
                if (!item[key]) {
                    item[key] = 0
                }
                // console.log(key + '=', item[key])
                total = total.plus(item[key])
            })
            if (typeof total == 'undefined') return 0
            return total.toNumber()
        },
        handleReset() {
            let length = this.data.length - 1
            if (length === 0) return
            this.tableData = this.data[this.data.length - 2]
            this.tableData = this.tableData.slice(0, this.tableData.length - 1)
            this.updata(this.tableData)
            this.tableData.push(this.total)
            this.data.splice(length, 1)
        },
        hanldeRowClick(row) {
            if (row.chirldren.length == 0) {
                return this.$router.push({
                    name: 'specialPayList',
                    params: {
                        value: row,
                    },
                })
            }
            let len = row.chirldren.length
            if (row.chirldren[len - 1].name == '总数') {
                row.chirldren.splice(len - 1, 1)
            }
            this.tableData = row.chirldren
            this.updata(this.tableData)
            this.tableData.push(this.total)
            this.data.push(row.chirldren)
        },
        handleCellClick(row, column) {
            // this.cstatus = column.label
        },
        updata(newVal) {
            this.total.name = '总数'
            this.total.payMoney = this.calculation('payMoney', newVal)
            this.total.projectCount = this.calculation('projectCount', newVal)
            this.total.projectMoney = this.calculation('projectMoney', newVal)
            // this.total.payRate = this.calculation('payRate', newVal)
            this.total.payRate = this.total.payMoney / this.total.projectMoney
            console.log(this.total.payMoney, this.total.projectMoney)
        },
        loadData(params) {
            if (!params) {
                params = ''
            }
            this.loading = true
            this.$http
                .get('${yhxt}/bizEngineeringProject/v1/projectMoneyReportCount' + params)
                .then((res) => {
                    this.tableData = (res && res.status == 200 && res.data) || []
                    this.updata(this.tableData)
                    this.tableData.push(this.total)
                    this.data = []
                    this.data.push(this.tableData)
                    this.loading = false
                })
                .catch(() => {
                    this.loading = false
                })
        },
    },
}
</script>

<style lang="scss" scoped>
/deep/ .el-date-editor {
    background-color: #103c5d;
    border: none;
}
/deep/ .el-range-separator {
    color: #fff;
}
/deep/ .el-table th.is-leaf {
    background-color: transparent !important;
}
/deep/ .el-table__row {
    background-color: #0b426e !important;
}
/deep/ .el-table__row--striped {
    background-color: #124873 !important;
}
/deep/ .el-table__header-wrapper {
    border-top-left-radius: 10px;
    border-top-right-radius: 10px;
}
/deep/ .el-table__body-wrapper {
    border-bottom-left-radius: 10px;
    border-bottom-right-radius: 10px;
}
/deep/ .el-table {
    background-color: transparent;
}
.container {
    padding: 30px;

    .header {
        height: 59px;
        width: 100%;
        display: flex;
        justify-content: space-between;
        border-bottom: 1px solid #4d7faf;
        .title {
            display: flex;
            height: 34px;
            align-items: center;
            .title-icon {
                display: block;
                width: 28px;
                height: 28px;
                background-image: url('../../assets/img/icon-标题@2x.png');
                background-size: 100% 100%;
            }
            .title-text {
                margin-left: 5px;
                height: 34px;
                font-size: 26px;
                font-family: Microsoft YaHei, Microsoft YaHei;
                font-weight: 700;
                line-height: 34px;
                color: transparent;
                -webkit-background-clip: text;
                background-image: linear-gradient(180deg, #e5f2ff 24%, #1f5c99 100%);
            }
        }
        .back-icon {
            margin-right: 10px;
            cursor: pointer;
            display: block;
            width: 40px;
            height: 40px;
            background-size: 100% 100%;
            background-image: url(../../assets//img/icon-返回@2x.png);
        }
    }
    .search {
        margin-top: 32px;
    }
    .table {
        margin-top: 12px;
        width: 100%;
        /deep/ .custom-header-cell {
            background-color: #145080 !important;
            padding: 15px 0;
            .cell {
                font-size: 18px;
                font-family: Microsoft YaHei, Microsoft YaHei;
                font-weight: 700;
                color: #e7edf0;
            }
        }
        /deep/ .custom-cell {
            padding: 15px 0;
            cursor: pointer;
            .cell,
            div {
                font-size: 16px;
                font-family: Microsoft YaHei, Microsoft YaHei;
                font-weight: 400;
                color: #e5f2ff;
            }
        }
        .table-total {
            display: flex;
            justify-content: center;
            align-items: center;
            height: 64px;
            background-color: #145080;
            border-radius: 10px;
            margin-top: 8px;
            span {
                font-size: 18px;
                font-family: Microsoft YaHei, Microsoft YaHei;
                font-weight: 700;
                color: #e7edf0;
                text-align: center;
                &:nth-child(1) {
                    width: 70px;
                }
                &:not(:nth-child(1)) {
                    flex: 1;
                }
            }
        }
    }
}
</style>
<style lang="scss">
.el-date-table td.disabled div {
    background-color: transparent;
    span {
        color: #666;
    }
}
</style>
